diff --git a/src/editor.c b/src/editor.c
index 6a5a0ae..261e66e 100644
--- a/src/editor.c
+++ b/src/editor.c
@@ -84,7 +84,7 @@ static GtkAccelGroup *snippet_accel_group = NULL;
 static gchar current_word[GEANY_MAX_WORD_LENGTH];
 
 /* whether there is a tag list update pending */
-static gboolean document_tags_update_pending = FALSE;
+static guint document_tags_update_source = 0;
 
 /* Initialised in keyfile.c. */
 GeanyEditorPrefs editor_prefs;
@@ -1001,19 +1001,17 @@ static gboolean on_document_update_tags_idle(gpointer data)
 	if (!main_status.quitting && DOC_VALID(doc))
 		document_update_tag_list(doc, TRUE);
 
-	document_tags_update_pending = FALSE;
+	document_tags_update_source = 0;
 	return FALSE;
 }
 
 
 static void request_tag_list_update(GeanyDocument *doc)
 {
-	if (!document_tags_update_pending)
-	{
-		document_tags_update_pending = TRUE;
-		g_timeout_add_full(G_PRIORITY_LOW, editor_prefs.autocompletion_update_freq,
-				on_document_update_tags_idle, doc, NULL);
-	}
+	if (document_tags_update_source)
+		g_source_remove(document_tags_update_source);		
+	document_tags_update_source = g_timeout_add_full(G_PRIORITY_LOW, editor_prefs.autocompletion_update_freq,
+		on_document_update_tags_idle, doc, NULL);
 }
 
 
